//-----------------------------------------------------------------------
// Vertex Shader files for this demo, it morph vertex of cube that initial in the program to a sphere using
// interplolation.
// ver1.0			DaveDzeng
// DEC 14
//---------------------------------------------------------------------------

// the extern constants
matrix World;
matrix View;
matrix 	WorldViewProj;  // World * View * Projection transformation

float 	Alpha;			  // Used to interplolate
float		Radius;			//Radius of the sphere

vector AmbientMtrl;		// material
vector DiffuseMtrl;

vector LightDirection;		//light

vector DiffuseLightIntensity;				//= {0.0f, 0.0f, 1.0f, 1.0f};
vector AmbientLightIntensity;				//= {0.0f, 0.0f, 0.2f, 1.0f};
vector SpecularIntensity ;					//= {0.5f, 0.5f, 0.5f, 1.0f};
//
// Input and Output structures.
//

struct VS_INPUT
{
    vector position : POSITION;
    vector normal   : NORMAL;
	float2 uvCoords : TEXCOORD;
};

struct VS_OUTPUT
{
    vector position : POSITION;
    vector diffuse  : COLOR;
	float2 uvCoords : TEXCOORD;
};

//
// Main
//

VS_OUTPUT Main(VS_INPUT input)
{
    // zero out all members of the output instance.
    VS_OUTPUT output = (VS_OUTPUT)0;
// Sphere 's postion as target postion
	vector inpos = input.position;
	inpos.w = 0.0f;
	vector spherenorm = normalize(inpos);
	if( Radius<0.0f)
	Radius = 0.0f;
	vector	 spherepos = spherenorm*Radius;
	spherepos.w = 1.0f;
	//input.position =
	Alpha = saturate(Alpha ) ;
	vector innorm = input.normal ;
	innorm.w = 0.0f;
	inpos = lerp(inpos , spherepos ,Alpha ) ;
	innorm = lerp( innorm, spherenorm ,Alpha ) ;
	inpos.w = 1.0f;
    // Transform position to homogeneous clip space
    // and store in the output.position member. 
    output.position = mul(inpos, WorldViewProj);	
    //
    // Transform lights and normals to view space.  Set w
    // componentes to zero since we're transforming vectors 
    // here and not points.
    //
   //Light postion is fixed ;  
    LightDirection.w = 0.0f;
    innorm     = mul(innorm,   World);
    innorm.w   = 0.0f; 
	innorm = normalize(innorm);
	LightDirection = normalize(LightDirection);
    // Compute cosine of the angle between light and normal.


    float s = dot(LightDirection, innorm);
    s= saturate( s );	
	//I thinks about to add some specular...
	//------------------------------------------------------------------------------------------------
	//the code below i compute the halfway vector use h.v to approximate r.v
	//the result turn out that i works ! before that i have to tranform them all to view space
	//------------------------------------------------------------------------------------------------
	vector ViewPos = {0.0f, 0.0f, -10.0f, 0.0f};
	inpos = mul(inpos , World *View);
	vector ViewDir = ViewPos - inpos ;
	ViewDir.w = 0.0f;
	ViewDir = normalize( ViewDir);
	LightDirection = mul(LightDirection ,View );
	LightDirection.w = 0.0f;
	LightDirection = normalize(LightDirection);
	vector r = LightDirection + ViewDir ;
	r.w = 0.0f;
	r = normalize (r);
	innorm = mul(innorm,View);
	vector specular = pow(saturate(dot( innorm,r)), 16);
	//*****************************************************************************
	//////////////////the code below didn't use halfway vector,instead compute the phong item directly
	//////////////////BUT it didn't works ,i don't know y!I guess when mul these matrix and vector some singular
	//////////////////condition appear,i left it for future debug works
	////////////////vector Reflect = ((2*s*10*innorm) - 10*LightDirection) ;
	//////////////////Reflect = normalize(Reflect );
	////////////////Reflect.w = 0.0f;
	////////////////Reflect = mul(Reflect ,View );
	////////////////Reflect.w = 0.0f;
	////////////////Reflect = normalize(Reflect );
	//////////////////reflect.w = 0.0f;
	////////////////vector ViewPos = {0.0f, 0.0f, -10.0f, 0.0f};
	/////////////////*View = transpose(View);*/
	////////////////vector posinview =mul(10*inpos , World);
	//////////////// posinview =mul(10*posinview , View);
	////////////////
	//////////////////ViewPos = mul(ViewPos ,View) ;
	////////////////vector ViewDir = ViewPos - posinview ;
	////////////////ViewDir.w = 0.0f;
	////////////////ViewDir = normalize( ViewDir);
	////////////////float t = dot( ViewDir,Reflect);
	//////////////////if( t < 0.0f )
	//////////////////        t = 0.0f;
	//////////////////        if( t > 1.0f )
	//////////////////        t = 0.0f;
	////////////////vector specular =pow(saturate(t), 8);	//RdotV^8
	//*****************************************************************************
	//finally we sum up  a ,d ,s item
    output.diffuse = (AmbientMtrl * AmbientLightIntensity) 
                     + (s * (DiffuseLightIntensity * DiffuseMtrl))
                     +specular*SpecularIntensity;
    output.uvCoords = input.uvCoords ;
    return output;
}