//--------------------------------------------------------------------------------------
// this file is the source ,origins from MS 's DXUT
// morph.vsh is the shader file
//	ver1.0 Dec 13 07  changed by DaveDzeng
//--------------------------------------------------------------------------------------
#pragma warning(disable:4995) //to eliminate the warning of deprecated

#include "dxstdafx.h"
#include "myvertex.h"
#include <vector>
//#define DEBUG_VS   // Uncomment this line to debug vertex shaders 
//#define DEBUG_PS   // Uncomment this line to debug pixel shaders 


//--------------------------------------------------------------------------------------
// Defines
//--------------------------------------------------------------------------------------
#define VERTS_PER_EDGE  20			//vertex of the cube
#define MYALPHA					1.2310f	//YOU SHOULD NEVER CHANGE THIS
																//   |\
																//   |   \ sphere's core, and alpha is angle there,don't change it
																//   |   /
																//   |/ 
#define CUBE_LENGTH		4.0f			//remain fixed when morphing
#define SPHERERADIUS       2.0f			//canbe changed in the demo with slider
#define MINIMOVETIME		0.005f		//the speed of the mophing
//--------------------------------------------------------------------------------------
// Global variables
//--------------------------------------------------------------------------------------
ID3DXFont*              g_pFont = NULL;         // Font for drawing text
ID3DXSprite*            g_pTextSprite = NULL;   // Sprite for batching draw text calls
CModelViewerCamera      g_Camera;               // A model viewing camera
bool                    g_bShowHelp = true;     // If true, it renders the UI control text
CDXUTDialogResourceManager g_DialogResourceManager; // manager for shared resources of dialogs
CD3DSettingsDlg         g_SettingsDlg;          // Device settings dialog
CDXUTDialog             g_HUD;                  // dialog for standard controls


// Scene
// I 'm so glad to have such similar code ,EXCELLENT!
// ************************************************************
DWORD                        g_dwNumVertices = VERTS_PER_EDGE * VERTS_PER_EDGE;
DWORD                        g_dwNumIndices = 6 * (VERTS_PER_EDGE - 1) * (VERTS_PER_EDGE - 1);
// ************************************************************
LPDIRECT3DVERTEXBUFFER9      g_pVB = NULL;
LPDIRECT3DINDEXBUFFER9       g_pIB = NULL;
LPDIRECT3DVERTEXSHADER9      g_pVertexShader = NULL;
LPD3DXCONSTANTTABLE          g_pConstantTable = NULL;
LPDIRECT3DVERTEXDECLARATION9 g_pVertexDeclaration = NULL;
//My stuff--------------
ID3DXMesh*									g_pMorphMesh = NULL; // mesh
FLOAT											g_fTickCount = 0.0f;		//timing for morphing
IDirect3DTexture9*							g_pTextures[6] = {0};		//Texture 
BOOL												g_bMophingStart = TRUE , g_bTextureOn = FALSE;	//for troggle button
CDXUTDialog								g_SampleUI ;					//My UI  to provide slider
FLOAT											g_CubeLength = CUBE_LENGTH;		//Cube length USELESS DEC 17 6pm
FLOAT											g_SphereRadius  = SPHERERADIUS; //Sphere radius
FLOAT											g_MiniMoveTime = MINIMOVETIME;//morphing speed

//--------------------------------------------------------------------------------------
// UI control IDs
//--------------------------------------------------------------------------------------
#define IDC_TOGGLEFULLSCREEN    1
#define IDC_TOGGLEREF           3
#define IDC_CHANGEDEVICE        4
//my UI stuff
#define IDC_STOPMORPHING			5
#define IDC_SLIDER							6
#define IDC_SLIDER2						7
#define IDC_TEXT								8
#define IDC_OUTPUT						9
#define IDC_OUTPUT2						10
#define IDC_SLIDER3						11
#define IDC_STOPTEXT						12
#define IDC_OUTPUT3						13

//--------------------------------------------------------------------------------------
// Forward declarations 
//--------------------------------------------------------------------------------------
bool    CALLBACK IsDeviceAcceptable( D3DCAPS9* pCaps, D3DFORMAT AdapterFormat, D3DFORMAT BackBufferFormat, bool bWindowed, void* pUserContext );
bool    CALLBACK ModifyDeviceSettings( DXUTDeviceSettings* pDeviceSettings, const D3DCAPS9* pCaps, void* pUserContext );
HRESULT CALLBACK OnCreateDevice( IDirect3DDevice9* pd3dDevice, const D3DSURFACE_DESC* pBackBufferSurfaceDesc, void* pUserContext );
HRESULT CALLBACK OnResetDevice( IDirect3DDevice9* pd3dDevice, const D3DSURFACE_DESC* pBackBufferSurfaceDesc, void* pUserContext );
void    CALLBACK OnFrameMove( IDirect3DDevice9* pd3dDevice, double fTime, float fElapsedTime, void* pUserContext );
void    CALLBACK OnFrameRender( IDirect3DDevice9* pd3dDevice, double fTime, float fElapsedTime, void* pUserContext );
LRESULT CALLBACK MsgProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam, bool* pbNoFurtherProcessing, void* pUserContext );
void    CALLBACK KeyboardProc( UINT nChar, bool bKeyDown, bool bAltDown, void* pUserContext );
void    CALLBACK OnGUIEvent( UINT nEvent, int nControlID, CDXUTControl* pControl, void* pUserContext );
void    CALLBACK OnLostDevice( void* pUserContext );
void    CALLBACK OnDestroyDevice( void* pUserContext );

void    InitApp();
void    RenderText();
void		InitialMtrl (IDirect3DDevice9* pd3dDevice, DWORD i);


//--------------------------------------------------------------------------------------
// Entry point to the program. Initializes everything and goes into a message processing 
// loop. Idle time is used to render the scene.
//--------------------------------------------------------------------------------------
INT WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR, int )
{
    // Enable run-time memory check for debug builds.
#if defined(DEBUG) | defined(_DEBUG)
    _CrtSetDbgFlag( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );
#endif

    // Set the callback functions. These functions allow DXUT to notify
    // the application about device changes, user input, and windows messages.  The 
    // callbacks are optional so you need only set callbacks for events you're interested 
    // in. However, if you don't handle the device reset/lost callbacks then the sample 
    // framework won't be able to reset your device since the application must first 
    // release all device resources before resetting.  Likewise, if you don't handle the 
    // device created/destroyed callbacks then DXUT won't be able to 
    // recreate your device resources.
    DXUTSetCallbackDeviceCreated( OnCreateDevice );
    DXUTSetCallbackDeviceReset( OnResetDevice );
    DXUTSetCallbackDeviceLost( OnLostDevice );
    DXUTSetCallbackDeviceDestroyed( OnDestroyDevice );
    DXUTSetCallbackMsgProc( MsgProc );
    DXUTSetCallbackKeyboard( KeyboardProc );
    DXUTSetCallbackFrameRender( OnFrameRender );
    DXUTSetCallbackFrameMove( OnFrameMove );

    // Show the cursor and clip it when in full screen
    DXUTSetCursorSettings( true, true );

    InitApp();

    // Initialize DXUT and create the desired Win32 window and Direct3D 
    // device for the application. Calling each of these functions is optional, but they
    // allow you to set several options which control the behavior of the framework.
    DXUTInit( true, true, true ); // Parse the command line, handle the default hotkeys, and show msgboxes
    DXUTCreateWindow( L"Morph for VS" );
    DXUTCreateDevice( D3DADAPTER_DEFAULT, true, 640, 480, IsDeviceAcceptable, ModifyDeviceSettings );

    // Pass control to DXUT for handling the message pump and 
    // dispatching render calls. DXUT will call your FrameMove 
    // and FrameRender callback when there is idle time between handling window messages.
    DXUTMainLoop(); 

    // Perform any application-level cleanup here. Direct3D device resources are released within the
    // appropriate callback functions and therefore don't require any cleanup code here.

    return DXUTGetExitCode();
}


//--------------------------------------------------------------------------------------
// Initialize the app 
//--------------------------------------------------------------------------------------
void InitApp()
{
    // Initialize dialogs
    g_SettingsDlg.Init( &g_DialogResourceManager );
    g_HUD.Init( &g_DialogResourceManager );
	g_SampleUI.Init( &g_DialogResourceManager );

    g_HUD.SetCallback( OnGUIEvent ); int iY = 10; 
    g_HUD.AddButton( IDC_TOGGLEFULLSCREEN, L"Toggle full screen", 35, iY, 125, 22 );
    g_HUD.AddButton( IDC_TOGGLEREF, L"Toggle REF (F3)", 35, iY += 24, 125, 22 );
    g_HUD.AddButton( IDC_CHANGEDEVICE, L"Change device (F2)", 35, iY += 24, 125, 22, VK_F2 );
	g_HUD.AddButton( IDC_STOPMORPHING, L"Toggle Morphing", 35, iY += 24, 125, 22 );
	g_HUD.AddButton( IDC_STOPTEXT, L"Toggle Texture", 35, iY += 24, 125, 22 );
	//g_SampleUI.SetFont( 1, L"Comic Sans MS", 24, FW_NORMAL );
 //   g_SampleUI.SetFont( 2, L"Courier New", 16, FW_NORMAL );
	g_SampleUI.SetCallback( OnGUIEvent );
	g_SampleUI.AddStatic( IDC_OUTPUT, 
		L"Slide to tune the radius of sphere", 20, iY += 24, 160, 22 );
	g_SampleUI.AddSlider( IDC_SLIDER, 35, iY += 24, 125, 22, 0, 100, 50, false );
	g_SampleUI.AddStatic( IDC_OUTPUT2, 
		L"Slide to tune the morphing of sphere", 5, iY += 24, 175, 22 );
	g_SampleUI.AddSlider( IDC_SLIDER2, 35, iY += 24, 125, 22, 0, 100, 50, false );
	g_SampleUI.AddStatic( IDC_OUTPUT2, 
		L"Slide to tune the speed of morphing", 5, iY += 24, 175, 22 );
	g_SampleUI.AddSlider( IDC_SLIDER3, 35, iY += 24, 125, 22, 0, 200, 100, false );
	//*****************************************************************
	//*****************************************************************
	//ADD YOU BUTTON
}


//--------------------------------------------------------------------------------------
// Called during device initialization, this code checks the device for some 
// minimum set of capabilities, and rejects those that don't pass by returning false.
//--------------------------------------------------------------------------------------
bool CALLBACK IsDeviceAcceptable( D3DCAPS9* pCaps, D3DFORMAT AdapterFormat, 
                                  D3DFORMAT BackBufferFormat, bool bWindowed, void* pUserContext )
{
    // Skip backbuffer formats that don't support alpha blending
    IDirect3D9* pD3D = DXUTGetD3DObject(); 
    if( FAILED( pD3D->CheckDeviceFormat( pCaps->AdapterOrdinal, pCaps->DeviceType,
                    AdapterFormat, D3DUSAGE_QUERY_POSTPIXELSHADER_BLENDING, 
                    D3DRTYPE_TEXTURE, BackBufferFormat ) ) )
        return false;

    return true;
}


//--------------------------------------------------------------------------------------
// This callback function is called immediately before a device is created to allow the 
// application to modify the device settings. The supplied pDeviceSettings parameter 
// contains the settings that the framework has selected for the new device, and the 
// application can make any desired changes directly to this structure.  Note however that 
// DXUT will not correct invalid device settings so care must be taken 
// to return valid device settings, otherwise IDirect3D9::CreateDevice() will fail.  
//--------------------------------------------------------------------------------------
bool CALLBACK ModifyDeviceSettings( DXUTDeviceSettings* pDeviceSettings, const D3DCAPS9* pCaps, void* pUserContext )
{
    // If device doesn't support HW T&L or doesn't support 1.1 vertex shaders in HW 
    // then switch to SWVP.
    if( (pCaps->DevCaps & D3DDEVCAPS_HWTRANSFORMANDLIGHT) == 0 ||
         pCaps->VertexShaderVersion < D3DVS_VERSION(1,1) )
    {
        pDeviceSettings->BehaviorFlags = D3DCREATE_SOFTWARE_VERTEXPROCESSING;
    }

    // Debugging vertex shaders requires either REF or software vertex processing 
    // and debugging pixel shaders requires REF.
#ifdef DEBUG_VS
    if( pDeviceSettings->DeviceType != D3DDEVTYPE_REF )
    {
        pDeviceSettings->BehaviorFlags &= ~D3DCREATE_HARDWARE_VERTEXPROCESSING;
        pDeviceSettings->BehaviorFlags &= ~D3DCREATE_PUREDEVICE;
        pDeviceSettings->BehaviorFlags |= D3DCREATE_SOFTWARE_VERTEXPROCESSING;
    }
#endif
#ifdef DEBUG_PS
    pDeviceSettings->DeviceType = D3DDEVTYPE_REF;
#endif

    // For the first device created if its a REF device, optionally display a warning dialog box
    static bool s_bFirstTime = true;
    if( s_bFirstTime )
    {
        s_bFirstTime = false;
        if( pDeviceSettings->DeviceType == D3DDEVTYPE_REF )
            DXUTDisplaySwitchingToREFWarning();
    }

    return true;
}


//--------------------------------------------------------------------------------------
// This callback function will be called immediately after the Direct3D device has been 
// created, which will happen during application initialization and windowed/full screen 
// toggles. This is the best location to create D3DPOOL_MANAGED resources since these 
// resources need to be reloaded whenever the device is destroyed. Resources created  
// here should be released in the OnDestroyDevice callback. 
//--------------------------------------------------------------------------------------
HRESULT CALLBACK OnCreateDevice( IDirect3DDevice9* pd3dDevice, const D3DSURFACE_DESC* pBackBufferSurfaceDesc, void* pUserContext )
{
    HRESULT hr;


    V_RETURN( g_DialogResourceManager.OnCreateDevice( pd3dDevice ) );
    V_RETURN( g_SettingsDlg.OnCreateDevice( pd3dDevice ) );
    // Initialize the font
    V_RETURN( D3DXCreateFont( pd3dDevice, 15, 0, FW_BOLD, 1, FALSE, DEFAULT_CHARSET, 
                         OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, 
                         L"Arial", &g_pFont ) );
// ************************************************************
    // Create vertex shader
    WCHAR        strPath[512];
    LPD3DXBUFFER pCode;

    D3DVERTEXELEMENT9 decl[] =
    {
        { 0, 0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
		{0, 12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL, 0},
		{0, 24, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0},
        D3DDECL_END()
    };

    V_RETURN( pd3dDevice->CreateVertexDeclaration( decl, &g_pVertexDeclaration ) );
    
    // Find the vertex shader file
    V_RETURN( DXUTFindDXSDKMediaFileCch( strPath, 512, L"..\\..\\data\\morph.vsh" ) );
    

    // Define DEBUG_VS and/or DEBUG_PS to debug vertex and/or pixel shaders with the 
    // shader debugger. Debugging vertex shaders requires either REF or software vertex 
    // processing, and debugging pixel shaders requires REF.  The 
    // D3DXSHADER_FORCE_*_SOFTWARE_NOOPT flag improves the debug experience in the 
    // shader debugger.  It enables source level debugging, prevents instruction 
    // reordering, prevents dead code elimination, and forces the compiler to compile 
    // against the next higher available software target, which ensures that the 
    // unoptimized shaders do not exceed the shader model limitations.  Setting these 
    // flags will cause slower rendering since the shaders will be unoptimized and 
    // forced into software.  See the DirectX documentation for more information about 
    // using the shader debugger.
    DWORD dwShaderFlags = 0;

    #if defined( DEBUG ) || defined( _DEBUG )
    // Set the D3DXSHADER_DEBUG flag to embed debug information in the shaders.
    // Setting this flag improves the shader debugging experience, but still allows 
    // the shaders to be optimized and to run exactly the way they will run in 
    // the release configuration of this program.
    dwShaderFlags |= D3DXSHADER_DEBUG;
    #endif

    #ifdef DEBUG_VS
        dwShaderFlags |= D3DXSHADER_SKIPOPTIMIZATION|D3DXSHADER_DEBUG;
    #endif
    #ifdef DEBUG_PS
        dwShaderFlags |= D3DXSHADER_SKIPOPTIMIZATION|D3DXSHADER_DEBUG;
    #endif

    // Assemble the vertex shader from the file
    V_RETURN( D3DXCompileShaderFromFile( L"..\\..\\data\\morph.vsh", NULL, NULL, "Main",
                                         "vs_1_1", dwShaderFlags, &pCode,
                                         NULL, &g_pConstantTable ) );


    // Create the vertex shader
    hr = pd3dDevice->CreateVertexShader( (DWORD*)pCode->GetBufferPointer(),
                                            &g_pVertexShader );
    pCode->Release();
    if( FAILED(hr) )
        return DXTRACE_ERR( TEXT("CreateVertexShader"), hr );


    // Setup the camera's view parameters
    //g_Camera.SetViewQuat( D3DXQUATERNION(-0.1f, 0.1f, 0.0f, 0.7f) );
	D3DXVECTOR3 EyePt(0.0f,0.0f,-10.0f ) , LookatPt(0.0f,0.0f,0.0f);
	g_Camera.SetViewParams( &EyePt, &LookatPt );

    return S_OK;
}


//--------------------------------------------------------------------------------------
// This callback function will be called immediately after the Direct3D device has been 
// reset, which will happen after a lost device scenario. This is the best location to 
// create D3DPOOL_DEFAULT resources since these resources need to be reloaded whenever 
// the device is lost. Resources created here should be released in the OnLostDevice 
// callback. 
//--------------------------------------------------------------------------------------
HRESULT CALLBACK OnResetDevice( IDirect3DDevice9* pd3dDevice, 
                                const D3DSURFACE_DESC* pBackBufferSurfaceDesc, void* pUserContext )
{
    HRESULT hr;

    V_RETURN( g_DialogResourceManager.OnResetDevice() );
    V_RETURN( g_SettingsDlg.OnResetDevice() );

    if( g_pFont )
        V_RETURN( g_pFont->OnResetDevice() );
    
    // Create a sprite to help batch calls when drawing many lines of text
    V_RETURN( D3DXCreateSprite( pd3dDevice, &g_pTextSprite ) );

//***************************************************************
	// Build up the mesh
	// Create mesh:
	V_RETURN(D3DXCreateMeshFVF(
		g_dwNumIndices*2,
		/*sizeof(MyVertex)**/g_dwNumVertices*6,
		D3DXMESH_MANAGED,
		D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1,
		pd3dDevice,
		&g_pMorphMesh));
    // Create and initialize index buffer
	//*****************************************************************
	//*****************************************************************
    WORD* pIndices;
	V_RETURN(g_pMorphMesh->LockIndexBuffer(0, (void**)&pIndices) );
    DWORD y;
	for ( int iCubePlane = 0 ; iCubePlane< 6 ; ++iCubePlane)
	{
		DWORD dwtail = iCubePlane*(g_dwNumVertices) ;
		for( y = 1; y < VERTS_PER_EDGE; y++ )
		{
			for( DWORD x = 1; x < VERTS_PER_EDGE; x++ )
			{
				*pIndices++ = (WORD)( (y-1)*VERTS_PER_EDGE + (x-1) +dwtail);
				*pIndices++ = (WORD)( (y-0)*VERTS_PER_EDGE + (x-1)+dwtail);
				*pIndices++ = (WORD)( (y-1)*VERTS_PER_EDGE + (x-0)+dwtail);

				*pIndices++ = (WORD)( (y-1)*VERTS_PER_EDGE + (x-0)+dwtail );
				*pIndices++ = (WORD)( (y-0)*VERTS_PER_EDGE + (x-1)+dwtail );
				*pIndices++ = (WORD)( (y-0)*VERTS_PER_EDGE + (x-0) +dwtail);
			}
		}
	}


    V_RETURN( g_pMorphMesh->UnlockIndexBuffer() );

	//*****************************************************************
	//*****************************************************************
    // Create and initialize vertex buffer
    MyVertex* pVertices ;
	V_RETURN( g_pMorphMesh->LockVertexBuffer(0, (void**)&pVertices) );
	DWORD dwsize = g_dwNumVertices ;
	for( y = 0; y < VERTS_PER_EDGE; y++ )
    {
        for( DWORD x = 0; x < VERTS_PER_EDGE; x++ )
        {
				float vx = 	sqrt(3.0f)*sin(MYALPHA *((VERTS_PER_EDGE-1)-2.0f*x)
					/(2*(VERTS_PER_EDGE-1)))/2.0f*CUBE_LENGTH;
				float vy =		sqrt(3.0f)*sin(MYALPHA *((VERTS_PER_EDGE-1)-2.0f*y)
					/(2*(VERTS_PER_EDGE-1)))/2.0f*CUBE_LENGTH;
				float u = vx *2.0f/CUBE_LENGTH;
				float v = vy *2.0f/CUBE_LENGTH;
	// -Z plane
			*pVertices = 
				MyVertex(
			/*x*/-vx, 
			/*y*/-vy,
			/*z*/	-CUBE_LENGTH/2.0f,
				0.0f, 0.0f,-1.0f,
				u+0.5f, 
				v+0.5f);
		// Z plane
				*((pVertices) + 1*dwsize) = 
					MyVertex(
				/*x*/	-vx, 
				/*y*/vy,//no - - 
				/*z*/	CUBE_LENGTH/2.0f,
					0.0f, 0.0f,1.0f,
					-u+0.5f, 
					v+0.5f);
	// X plane
			*((pVertices) + 2*dwsize) = 
				MyVertex(
			/*x*/	CUBE_LENGTH/2.0f,
			/*y*/	-vy, 
			/*z*/	-vx,
				1.0f, 0.0f,0.0f,
				v+0.5f, 
				u+0.5f);
	// -X plane
			*((pVertices) + 3*dwsize) = 
				MyVertex(
			/*x*/	-CUBE_LENGTH/2.0f,
			/*y*/	vy, 
			/*z*/	-vx,
				-1.0f, 0.0f,0.0f,
				v+0.5f, 
				-u+0.5f);
	// Y plane
			*((pVertices) + 4*dwsize) = 
				MyVertex(
			/*x*/	vy, 
			/*y*/	CUBE_LENGTH/2.0f,
			/*z*/	-vx,
				0.0f, 1.0f,0.0f,
				u+0.5f, 
				v+0.5f);
  // -Y plane
			*((pVertices++) + 5*dwsize) = 
				MyVertex(
			/*x*/	vy, 
			/*y*/-CUBE_LENGTH/2.0f,
			/*z*/vx,
				0.0f, -1.0f,0.0f,
				-u+0.5f, 
				v+0.5f);//right!!
        }
    }


    V_RETURN( g_pMorphMesh->UnlockVertexBuffer() );
	//*****************************************************************
	//*****************************************************************
	DWORD* attributeBuffer = 0;
	V_RETURN(g_pMorphMesh->LockAttributeBuffer(0, &attributeBuffer));
	// Initial the attributeBuffer for subset
	for ( int iCubePlane = 0 ; iCubePlane< 6 ; ++iCubePlane)
	{
		for(DWORD a = iCubePlane* g_dwNumIndices/3 ; 
			a < g_dwNumIndices/3+iCubePlane* g_dwNumIndices/3; a++)
			attributeBuffer[a] = iCubePlane;
	}

	V_RETURN(g_pMorphMesh->UnlockAttributeBuffer());
	//*****************************************************************
	//*****************************************************************
	// Optimize the mesh to generate an attribute table.

	std::vector<DWORD> adjacencyBuffer(g_pMorphMesh->GetNumFaces() * 3);
	/*g_adjacencyBuffer = new DWORD (g_pMorphMesh->GetNumFaces() * 3);*/
	g_pMorphMesh->GenerateAdjacency(0.0f, &adjacencyBuffer[0]);

	V_RETURN(
		g_pMorphMesh->OptimizeInplace(		
		D3DXMESHOPT_ATTRSORT |
		D3DXMESHOPT_COMPACT  |
		D3DXMESHOPT_VERTEXCACHE,
		&adjacencyBuffer[0],
		0, 0, 0)
	);
	// Load the textures and set filters.
	D3DXCreateTextureFromFile(pd3dDevice,L"..\\..\\data\\checker.jpg",&g_pTextures[0]);
	D3DXCreateTextureFromFile(pd3dDevice,L"..\\..\\data\\checker.jpg",&g_pTextures[1]);
	D3DXCreateTextureFromFile(pd3dDevice,L"..\\..\\data\\checker.jpg",&g_pTextures[2]);
	D3DXCreateTextureFromFile(pd3dDevice,L"..\\..\\data\\checker.jpg",&g_pTextures[3]);
	D3DXCreateTextureFromFile(pd3dDevice,L"..\\..\\data\\checker.jpg",&g_pTextures[4]);
	D3DXCreateTextureFromFile(pd3dDevice,L"..\\..\\data\\checker.jpg",&g_pTextures[5]);

	pd3dDevice->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	pd3dDevice->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	pd3dDevice->SetSamplerState(0, D3DSAMP_MIPFILTER, D3DTEXF_POINT);

	//*****************************************************************
	//*****************************************************************
    // Setup the camera's projection parameters
    float fAspectRatio = pBackBufferSurfaceDesc->Width / (FLOAT)pBackBufferSurfaceDesc->Height;
    g_Camera.SetProjParams( D3DX_PI/4, fAspectRatio, 0.1f, 1000.0f );
    g_Camera.SetWindow( pBackBufferSurfaceDesc->Width, pBackBufferSurfaceDesc->Height );

    g_HUD.SetLocation( pBackBufferSurfaceDesc->Width-200, 0 );
    g_HUD.SetSize( 170, 170 );
	g_SampleUI.SetLocation( pBackBufferSurfaceDesc->Width-200, 0 );
    g_SampleUI.SetSize( 170, 170 );
    
    return S_OK;
}


//--------------------------------------------------------------------------------------
// This callback function will be called once at the beginning of every frame. This is the
// best location for your application to handle updates to the scene, but is not 
// intended to contain actual rendering calls, which should instead be placed in the 
// OnFrameRender callback.  
//--------------------------------------------------------------------------------------
void CALLBACK OnFrameMove( IDirect3DDevice9* pd3dDevice, double fTime, float fElapsedTime, void* pUserContext )
{

    // Update the camera's position based on user input 
    g_Camera.FrameMove( fElapsedTime );

    // Set up the vertex shader constants
    D3DXMATRIXA16 mWorldViewProj;
    D3DXMATRIXA16 mWorld;
    D3DXMATRIXA16 mView;
    D3DXMATRIXA16 mProj;

    mWorld = *g_Camera.GetWorldMatrix();
    mView  = *g_Camera.GetViewMatrix();
    mProj  = *g_Camera.GetProjMatrix();

    mWorldViewProj = mWorld * mView * mProj;
	/*D3DXMatrixInverse(&mView,NULL,&mView);*/
	g_pConstantTable->SetMatrix( pd3dDevice, "World", &mWorld );
	g_pConstantTable->SetMatrix( pd3dDevice, "View", &mView );
	/*pd3dDevice->SetTransform(D3DTS_WORLD, &mWorldViewProj);*/
	// Light direction:
	D3DXVECTOR4 directionToLight(1.0f, 1.0f, -0.5f, 0.0f);
	g_pConstantTable->SetVector(pd3dDevice, "LightDirection", &directionToLight);
	/*g_pConstantTable->SetDefaults(pd3dDevice);*/
    g_pConstantTable->SetMatrix( pd3dDevice, "WorldViewProj", &mWorldViewProj );
	if (g_bMophingStart )
	g_fTickCount += g_MiniMoveTime;
    g_pConstantTable->SetFloat( pd3dDevice, "Alpha", (float) abs(sin(g_fTickCount)));
	g_pConstantTable->SetFloat( pd3dDevice, "Radius", g_SphereRadius );
	
}


//--------------------------------------------------------------------------------------
// This callback function will be called at the end of every frame to perform all the 
// rendering calls for the scene, and it will also be called if the window needs to be 
// repainted. After this function has returned, DXUT will call 
// IDirect3DDevice9::Present to display the contents of the next buffer in the swap chain
//--------------------------------------------------------------------------------------
void CALLBACK OnFrameRender( IDirect3DDevice9* pd3dDevice, double fTime, float fElapsedTime, void* pUserContext )
{
    // If the settings dialog is being shown, then
    // render it instead of rendering the app's scene
    if( g_SettingsDlg.IsActive() )
    {
        g_SettingsDlg.OnRender( fElapsedTime );
        return;
    }

    HRESULT hr;

     //Clear the render target and the zbuffer 
    V( pd3dDevice->Clear(0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_ARGB(255, 15, 15, 115), 1.0f, 0) );

    // Render the scene
    if( SUCCEEDED( pd3dDevice->BeginScene() ) )
    {
        pd3dDevice->SetVertexDeclaration( g_pVertexDeclaration );
        pd3dDevice->SetVertexShader( g_pVertexShader );
		pd3dDevice->SetTextureStageState(0, D3DTSS_COLOROP , D3DTOP_ADDSIGNED );
		/*pd3dDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,
															D3DTOP_SELECTARG1);*/
		for ( int iCubePlane = 0 ; iCubePlane< 6 ; ++iCubePlane)
		{
			InitialMtrl (pd3dDevice, iCubePlane);
			if ( g_bTextureOn)
				pd3dDevice->SetTexture(0,g_pTextures[iCubePlane]);		//any texture you like
			else pd3dDevice->SetTexture(0,NULL);
			V(g_pMorphMesh->DrawSubset( iCubePlane )  );
		}

        RenderText();
        V( g_HUD.OnRender( fElapsedTime ) );
		V(g_SampleUI.OnRender( fElapsedTime ));
        
        V( pd3dDevice->EndScene() );
    }
}


//--------------------------------------------------------------------------------------
// Render the help and statistics text. This function uses the ID3DXFont interface for 
// efficient text rendering.
//--------------------------------------------------------------------------------------
void RenderText()
{
    // The helper object simply helps keep track of text position, and color
    // and then it calls pFont->DrawText( g_pSprite, strMsg, -1, &rc, DT_NOCLIP, g_clr );
    // If NULL is passed in as the sprite object, then it will work however the 
    // pFont->DrawText() will not be batched together.  Batching calls will improves performance.
    CDXUTTextHelper txtHelper( g_pFont, g_pTextSprite, 15 );

    // Output statistics
    txtHelper.Begin();
    txtHelper.SetInsertionPos( 5, 5 );
    txtHelper.SetForegroundColor( D3DXCOLOR( 1.0f, 1.0f, 0.0f, 1.0f ) );
    txtHelper.DrawTextLine( L"Drag with LeftButton down to Rotate the Cube" );
	 txtHelper.DrawTextLine( L"Drag with RightButton down to Change the View Direction" );
    //txtHelper.DrawTextLine( DXUTGetDeviceStats() );

    txtHelper.SetForegroundColor( D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ) );
    
    // Draw help
    //if( g_bShowHelp )
    //{
    //    const D3DSURFACE_DESC* pd3dsdBackBuffer = DXUTGetBackBufferSurfaceDesc();
    //    txtHelper.SetInsertionPos( 10, pd3dsdBackBuffer->Height-15*6 );
    //    txtHelper.SetForegroundColor( D3DXCOLOR( 1.0f, 0.75f, 0.0f, 1.0f ) );
    //    txtHelper.DrawTextLine( L"Controls (F1 to hide):" );

    //    txtHelper.SetInsertionPos( 40, pd3dsdBackBuffer->Height-15*5 );
    //    txtHelper.DrawTextLine( L"Rotate model: Left mouse button\n"
    //                            L"Rotate camera: Right mouse button\n"
    //                            L"Zoom camera: Mouse wheel scroll\n"
    //                            L"Hide help: F1" );                                      
    //}
    //else
    //{
    //    txtHelper.SetForegroundColor( D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ) );
    //    txtHelper.DrawTextLine( L"Press F1 for help" );
    //}

    txtHelper.End();
}


//--------------------------------------------------------------------------------------
// Before handling window messages, DXUT passes incoming windows 
// messages to the application through this callback function. If the application sets 
// *pbNoFurtherProcessing to TRUE, then DXUT will not process this message.
//--------------------------------------------------------------------------------------
LRESULT CALLBACK MsgProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam, bool* pbNoFurtherProcessing, void* pUserContext )
{
    // Always allow dialog resource manager calls to handle global messages
    // so GUI state is updated correctly
    *pbNoFurtherProcessing = g_DialogResourceManager.MsgProc( hWnd, uMsg, wParam, lParam );
    if( *pbNoFurtherProcessing )
        return 0;

    if( g_SettingsDlg.IsActive() )
    {
        g_SettingsDlg.MsgProc( hWnd, uMsg, wParam, lParam );
        return 0;
    }

    // Give the dialogs a chance to handle the message first
    *pbNoFurtherProcessing = g_HUD.MsgProc( hWnd, uMsg, wParam, lParam );
    if( *pbNoFurtherProcessing )
        return 0;
	//*****************************************************************
	 *pbNoFurtherProcessing = g_SampleUI.MsgProc( hWnd, uMsg, wParam, lParam );
    if( *pbNoFurtherProcessing )
        return 0;
	//*****************************************************************
    
    // Pass all remaining windows messages to camera so it can respond to user input
    g_Camera.HandleMessages( hWnd, uMsg, wParam, lParam );
    return 0;
}


//--------------------------------------------------------------------------------------
// As a convenience, DXUT inspects the incoming windows messages for
// keystroke messages and decodes the message parameters to pass relevant keyboard
// messages to the application.  The framework does not remove the underlying keystroke 
// messages, which are still passed to the application's MsgProc callback.
//--------------------------------------------------------------------------------------
void CALLBACK KeyboardProc( UINT nChar, bool bKeyDown, bool bAltDown, void* pUserContext )
{
    if( bKeyDown )
    {
        switch( nChar )
        {
            case VK_F1: g_bShowHelp = !g_bShowHelp; break;
        }
    }
}


//--------------------------------------------------------------------------------------
// Handles the GUI events
//--------------------------------------------------------------------------------------
void CALLBACK OnGUIEvent( UINT nEvent, int nControlID, CDXUTControl* pControl, void* pUserContext )
{
    switch( nControlID )
    {
        case IDC_TOGGLEFULLSCREEN: DXUTToggleFullScreen(); break;
        case IDC_TOGGLEREF:        DXUTToggleREF(); break;
        case IDC_CHANGEDEVICE:     g_SettingsDlg.SetActive( !g_SettingsDlg.IsActive() ); break;
		case IDC_STOPMORPHING:	
			{	if (g_bMophingStart ) g_bMophingStart = false;else g_bMophingStart  = true;break;}
		case IDC_STOPTEXT:
			{	if (g_bTextureOn ) g_bTextureOn = false;else g_bTextureOn  = true;break;}	
		case IDC_SLIDER:
			{ g_SphereRadius = (  ((CDXUTSlider*)(pControl))->GetValue() )/10.0f;break;}
		case IDC_SLIDER2:
			{ g_bMophingStart = false;g_fTickCount = (  ((CDXUTSlider*)(pControl))->GetValue() )/100.0f*D3DX_PI/2.0f ;break;}
		case IDC_SLIDER3:
			{g_MiniMoveTime= (  ((CDXUTSlider*)(pControl))->GetValue() )/10000.0f;break;}
    }
}


//--------------------------------------------------------------------------------------
// This callback function will be called immediately after the Direct3D device has 
// entered a lost state and before IDirect3DDevice9::Reset is called. Resources created
// in the OnResetDevice callback should be released here, which generally includes all 
// D3DPOOL_DEFAULT resources. See the "Lost Devices" section of the documentation for 
// information about lost devices.
//--------------------------------------------------------------------------------------
void CALLBACK OnLostDevice( void* pUserContext )
{
    g_DialogResourceManager.OnLostDevice();
    g_SettingsDlg.OnLostDevice();
    if( g_pFont )
        g_pFont->OnLostDevice();
    
    SAFE_RELEASE( g_pIB );
    SAFE_RELEASE( g_pVB );
    SAFE_RELEASE( g_pTextSprite );
	SAFE_RELEASE( g_pMorphMesh );
	for ( int i = 0 ; i < 6 ; ++ i ) 
	{
		SAFE_RELEASE( g_pTextures[i]);
	}
}


//--------------------------------------------------------------------------------------
// This callback function will be called immediately after the Direct3D device has 
// been destroyed, which generally happens as a result of application termination or 
// windowed/full screen toggles. Resources created in the OnCreateDevice callback 
// should be released here, which generally includes all D3DPOOL_MANAGED resources. 
//--------------------------------------------------------------------------------------
void CALLBACK OnDestroyDevice( void* pUserContext )
{
    g_DialogResourceManager.OnDestroyDevice();
    g_SettingsDlg.OnDestroyDevice();
    SAFE_RELEASE( g_pFont );
    SAFE_RELEASE( g_pVertexShader );
    SAFE_RELEASE( g_pConstantTable );
    SAFE_RELEASE( g_pVertexDeclaration );
	
	
}

void	InitialMtrl (IDirect3DDevice9* pd3dDevice, DWORD i)
{
		// Materials:
	D3DXVECTOR4 SpecularIntensity(1.0f, 1.0f, 1.0f, 1.0f);
	g_pConstantTable->SetVector(pd3dDevice, "SpecularIntensity", &SpecularIntensity);
	switch ( i )
	{
	case 0: 
		{
			D3DXVECTOR4 ambientMtrl(0.1f, 0.0f, 0.0f, 0.0f);
			D3DXVECTOR4 diffuseMtrl(1.0f, 0.0f, 0.0f, 0.0f);
			D3DXVECTOR4 DiffuseLightIntensity(1.0f, 1.0f, 1.0f, 1.0f);
			D3DXVECTOR4 AmbientLightIntensity(0.1f, 0.1f, 0.1f, 0.1f);

			g_pConstantTable->SetVector(pd3dDevice,"AmbientMtrl",&ambientMtrl);
			g_pConstantTable->SetVector(pd3dDevice,"DiffuseMtrl",&diffuseMtrl);
			g_pConstantTable->SetVector(pd3dDevice,"DiffuseLightIntensity",&DiffuseLightIntensity);
			g_pConstantTable->SetVector(pd3dDevice,"AmbientLightIntensity",&AmbientLightIntensity);
			break;
		}
	case 1:
		{
			D3DXVECTOR4 ambientMtrl(0.0f, 0.1f, 0.0f, 0.0f);
			D3DXVECTOR4 diffuseMtrl(0.0f, 1.0f, 0.0f, 0.0f);
			D3DXVECTOR4 DiffuseLightIntensity(1.0f, 1.0f, 1.0f, 1.0f);
			D3DXVECTOR4 AmbientLightIntensity(0.1f, 0.1f, 0.1f, 0.1f);

			g_pConstantTable->SetVector(pd3dDevice,"AmbientMtrl",&ambientMtrl);
			g_pConstantTable->SetVector(pd3dDevice,"DiffuseMtrl",&diffuseMtrl);
			g_pConstantTable->SetVector(pd3dDevice,"DiffuseLightIntensity",&DiffuseLightIntensity);
			g_pConstantTable->SetVector(pd3dDevice,"AmbientLightIntensity",&AmbientLightIntensity);
			break;
		}
	case 2:
		{
			D3DXVECTOR4 ambientMtrl(0.0f, 0.0f, 0.1f, 0.0f);
			D3DXVECTOR4 diffuseMtrl(0.0f, 0.0f, 1.0f, 0.0f);
			D3DXVECTOR4 DiffuseLightIntensity(1.0f, 1.0f, 1.0f, 1.0f);
			D3DXVECTOR4 AmbientLightIntensity(0.1f, 0.1f, 0.1f, 0.1f);

			g_pConstantTable->SetVector(pd3dDevice,"AmbientMtrl",&ambientMtrl);
			g_pConstantTable->SetVector(pd3dDevice,"DiffuseMtrl",&diffuseMtrl);
			g_pConstantTable->SetVector(pd3dDevice,"DiffuseLightIntensity",&DiffuseLightIntensity);
			g_pConstantTable->SetVector(pd3dDevice,"AmbientLightIntensity",&AmbientLightIntensity);
			break;
		}
	case 3:
		{
			D3DXVECTOR4 ambientMtrl(0.1f, 0.1f, 0.0f, 0.0f);
			D3DXVECTOR4 diffuseMtrl(1.0f, 1.0f, 0.0f, 0.0f);
			D3DXVECTOR4 DiffuseLightIntensity(1.0f, 1.0f, 1.0f,1.0f);
			D3DXVECTOR4 AmbientLightIntensity(0.1f, 0.1f, 0.1f, 0.1f);

			g_pConstantTable->SetVector(pd3dDevice,"AmbientMtrl",&ambientMtrl);
			g_pConstantTable->SetVector(pd3dDevice,"DiffuseMtrl",&diffuseMtrl);
			g_pConstantTable->SetVector(pd3dDevice,"DiffuseLightIntensity",&DiffuseLightIntensity);
			g_pConstantTable->SetVector(pd3dDevice,"AmbientLightIntensity",&AmbientLightIntensity);
			break;
		}
	case 4:
		{
			D3DXVECTOR4 ambientMtrl(0.0f, 0.1f, 0.1f, 0.0f);
			D3DXVECTOR4 diffuseMtrl(0.0f, 1.0f, 1.0f, 0.0f);
			D3DXVECTOR4 DiffuseLightIntensity(1.0f, 1.0f, 1.0f, 1.0f);
			D3DXVECTOR4 AmbientLightIntensity(0.1f, 0.1f, 0.1f, 0.1f);

			g_pConstantTable->SetVector(pd3dDevice,"AmbientMtrl",&ambientMtrl);
			g_pConstantTable->SetVector(pd3dDevice,"DiffuseMtrl",&diffuseMtrl);
			g_pConstantTable->SetVector(pd3dDevice,"DiffuseLightIntensity",&DiffuseLightIntensity);
			g_pConstantTable->SetVector(pd3dDevice,"AmbientLightIntensity",&AmbientLightIntensity);
			break;
		}
	case 5:
		{
			D3DXVECTOR4 ambientMtrl(0.1f, 0.0f, 0.1f, 0.0f);
			D3DXVECTOR4 diffuseMtrl(1.0f, 0.0f, 1.0f, 0.0f);
			D3DXVECTOR4 DiffuseLightIntensity(1.0f, 1.0f, 1.0f,1.0f);
			D3DXVECTOR4 AmbientLightIntensity(0.1f, 0.1f, 0.1f, 0.1f);

			g_pConstantTable->SetVector(pd3dDevice,"AmbientMtrl",&ambientMtrl);
			g_pConstantTable->SetVector(pd3dDevice,"DiffuseMtrl",&diffuseMtrl);
			g_pConstantTable->SetVector(pd3dDevice,"DiffuseLightIntensity",&DiffuseLightIntensity);
			g_pConstantTable->SetVector(pd3dDevice,"AmbientLightIntensity",&AmbientLightIntensity);
			break;
		}
	default:break;
	}
}
